#ifndef CORE_H
#define CORE_H

#include <QObject>
#include "smartlightserver.h"
#include "interfaceserver.h"
#include "logthread.h"
#include "wssserver.h"
#include "databasethread.h"

class Core : public QObject
{
    Q_OBJECT
public:
    explicit Core(QObject *parent = nullptr);
    void start();

signals:

public slots:
    void CommData(QString deviceID, int dir, QString data);
    void getEAlarm(QString DeviceCode, int erc, int sta, int arg1, int arg2, int arg3, float value, float v2, QString others, QDateTime t);
    void sql_log(QString log);
    void resetRequest(QString deviceID, int commandType, int parameterType, int pseq);
    void requestRealTimeData(QString deviceID, int commandType, int parameterType, int pn, int queryNumber, int startPoint);
    void requestSetParameters(QString deviceID, int commandType, int parameterType, QString tmp);

private:
    SmartLightServer *server;
    InterfaceServer *intServer;
    LogThread *logThread;
    DatabaseThread *dbThread;
    WssServer *wssServer;
};

#endif // CORE_H
