#ifndef DATABASETHREAD_H
#define DATABASETHREAD_H

#include <QThread>
#include <QDateTime>
#include <QDir>
#include <QFile>
#include <QSqlDatabase>
#include <QSqlQuery>
#include <QVariant>
#include <QStringList>

class DatabaseThread : public QThread
{
    Q_OBJECT
public:
    enum {
        ConfSql = 0,
        RecSql = 1,
        StaSql = 2
    }SqlType;
    explicit DatabaseThread(QObject *parent = nullptr);
    ~DatabaseThread();
    bool db_init();
    bool had_table(QStringList tblist, QString tbname);
    void db_load();
    void appendSql(int type, QString sql);
    void run();
    void stop();

signals:
    void sql_log(QString log);
public slots:

private:
    bool keep;
    QSqlDatabase conf_db, rec_db, sta_db;
    QStringList ConfSqlList, RecSqlList, StaSqlList;
};

#endif // DATABASETHREAD_H
