#ifndef INTERFACETHREAD_H
#define INTERFACETHREAD_H

#include <QThread>
#include <QHostAddress>
#include <QTcpSocket>
#include <QString>
#include <QDateTime>
#include <QJsonDocument>
#include <QJsonObject>
#include <QJsonArray>
#include <QJsonValue>
#include <QVariant>
#include <QJsonParseError>
#include <QStringList>
#include <QList>
#include <QObject>
#include <QUuid>
#include <QRegExp>

class InterfaceThread : public QThread
{
    Q_OBJECT
public:
    explicit InterfaceThread(qintptr socketDescriptor, QObject *parent = nullptr);
    ~InterfaceThread() override;
    void run() override;
    void setEchoString(QString string);
    bool chkCmdID(QString id);
    QString cmdID(){
        return CmdId;
    }

signals://根据与平台的协议格式制定
    void resetRequest(QString deviceID, int commandType, int parameterType, int pseq);
    void requestRealTimeData(QString deviceID, int commandType, int parameterType, int pn, int queryNumber, int startPoint);
    void requestSetParameters(QString deviceID, int commandType, int parameterType, QString tmp);
    void CommData(QString deviceID, int dir, QString data);

public slots:

private:
    qintptr SocketDescriptor;
    QString CmdId, EchoString;
    bool waitEcho;
    bool getEcho;
};

#endif // INTERFACETHREAD_H
